﻿using Benday.FakesSample.Common;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Benday.FakesSample.DataAccess
{
    public class SqlPersonRepository : IRepository<IPerson>
    {
        public IList<IPerson> GetAll()
        {
            throw new NotImplementedException();
        }

        public IPerson GetById(int id)
        {
            PersonDataAccess dataAccess = new PersonDataAccess();

            var datarow = dataAccess.LoadPerson(id);

            var person = new Person(
                datarow.Id,
                datarow.FirstName,
                datarow.LastName,
                datarow.EmailAddress,
                datarow.Notes,
                datarow.CreateDate,
                datarow.LastModified);

            return person;
        }

        public void Save(IPerson saveThis)
        {
            if (saveThis.Id == 0)
            {
                SaveNew(saveThis);
            }
            else
            {
                SaveExisting(saveThis);
            }
        }

        private void SaveNew(IPerson saveThis)
        {
            PersonDataAccess dataAccess = new PersonDataAccess();

            saveThis.CreateDate = DateTime.Now;
            saveThis.LastModified = DateTime.Now;

            var datarow =
                new FakesDataSet().Person.AddPersonRow(
                    saveThis.FirstName,
                    saveThis.LastName,
                    saveThis.EmailAddress,
                    saveThis.Notes,
                    saveThis.CreateDate,
                    saveThis.LastModified);

            dataAccess.SavePerson(datarow);

            saveThis.Id = datarow.Id;
        }

        private void SaveExisting(IPerson saveThis)
        {
            PersonDataAccess dataAccess = new PersonDataAccess();

            var datarow = dataAccess.LoadPerson(saveThis.Id);

            if (datarow == null)
            {
                throw new InvalidOperationException("Unknown person.");
            }

            saveThis.LastModified = DateTime.Now;

            datarow.FirstName = saveThis.FirstName;
            datarow.LastName = saveThis.LastName;

            if (datarow.EmailAddress != saveThis.EmailAddress)
            {
                datarow.EmailAddress = saveThis.EmailAddress;
            }

            datarow.Notes = saveThis.Notes;
            datarow.CreateDate = saveThis.CreateDate;
            datarow.LastModified = saveThis.LastModified;

            dataAccess.SavePerson(datarow);
        }

        public void Delete(IPerson deleteThis)
        {
            throw new NotImplementedException();
        }
    }
}
